# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::V7_2_preview
  module Models
    #
    # The key update parameters.
    #
    class KeyUpdateParameters

      include MsRestAzure

      # @return [Array<JsonWebKeyOperation>] Json web key operations. For more
      # information on possible key operations, see JsonWebKeyOperation.
      attr_accessor :key_ops

      # @return [KeyAttributes]
      attr_accessor :key_attributes

      # @return [Hash{String => String}] Application specific metadata in the
      # form of key-value pairs.
      attr_accessor :tags

      # @return [KeyReleasePolicy] The policy rules under which the key can be
      # exported.
      attr_accessor :release_policy


      #
      # Mapper for KeyUpdateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'KeyUpdateParameters',
          type: {
            name: 'Composite',
            class_name: 'KeyUpdateParameters',
            model_properties: {
              key_ops: {
                client_side_validation: true,
                required: false,
                serialized_name: 'key_ops',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'JsonWebKeyOperationElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              key_attributes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'attributes',
                type: {
                  name: 'Composite',
                  class_name: 'KeyAttributes'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              release_policy: {
                client_side_validation: true,
                required: false,
                serialized_name: 'release_policy',
                type: {
                  name: 'Composite',
                  class_name: 'KeyReleasePolicy'
                }
              }
            }
          }
        }
      end
    end
  end
end
